
gs.markov.blanket = function(target, data, nodes, alpha, extra.args = list(),
    whitelist, blacklist, start = character(0), test, max.sx = ncol(data),
    debug = FALSE) {

  nodes = nodes[nodes != target]
  whitelisted = nodes[sapply(nodes,
        function(y) { is.whitelisted(whitelist, c(target, y), either = TRUE) })]
  mb = start

  # growing phase
  if (debug) {

    cat("----------------------------------------------------------------\n")
    cat("* learning the markov blanket of ", target, ".\n", sep = "")

    if (length(start) > 0)
      cat("* initial set includes '", paste(mb, collapse = " "), "'.\n", sep = "")

  }#THEN

  # whitelisted nodes are included by default (if there's a direct arc
  # between them of course they are in each other's markov blanket).
  # arc direction is irrelevant here.
  mb = unique(c(mb, whitelisted))
  nodes = nodes[nodes %!in% mb]
  # blacklist is not checked, not all nodes in a markov blanket must be
  # neighbours.

  # grow phase.
  repeat {

    # store the current size of the Markov Blanket.
    mb.size = length(mb)

    for (y in nodes) {

      # avoid testing with large conditioning sets.
      if (mb.size > max.sx) {

        if (debug)
          cat("  * skipping node ", y,
              " because the tests would involve a conditioning set larger than ",
              max.sx, ".\n", sep = "")

        next

      }#THEN

      if (debug)
        cat("  * checking node ", y, " for inclusion.\n", sep = "")


      a = indep.test(target, y, mb, data = data, test = test,
            extra.args = extra.args, alpha = alpha, debug = debug)

      if (a <= alpha) {

        # add the node to the Markov blanket.
        mb = c(mb, y)
        # do not check the same node again.
        nodes = nodes[nodes != y]

        if (debug) {

          cat("    > node ", y, " included in the markov blanket (p-value: ", a, ").\n", sep = "")
          cat("    > markov blanket (", length(mb), " nodes) now is '", paste(mb, collapse = " "), "'.\n", sep = "")
          cat("    > restarting grow loop.\n")

        }#THEN

        break

      }#THEN

    }#FOR

    # if the Markov blanket is unchanged exit the grow phase.
    if (length(mb) == mb.size) break

  }#REPEAT

  # whitelisted nodes are neighbours, they cannot be removed from the
  # markov blanket.
  nodes = mb[mb %!in% whitelisted]

  # shrinking phase.
  repeat {

    # store the current size of the Markov Blanket.
    mb.size = length(mb)

    for (y in nodes) {

      if (debug)
        cat("  * checking node ", y, " for exclusion (shrinking phase).\n", sep = "")

      a = indep.test(target, y, mb[mb != y], data = data, test = test,
            extra.args = extra.args, alpha = alpha, debug = debug)

      if (a > alpha) {

        # update the markov blanket.
        mb = mb[mb != y]
        # do not check the same node again.
        nodes = nodes[nodes != y]

        if (debug) {

          cat("    > node ", y, " removed from the markov blanket. (p-value: ", a, ")\n", sep = "")
          cat("    > conditioning subset: '", paste(mb, collapse = " "), "'\n", sep = "")
          cat("    > restarting shrink loop.\n")

        }#THEN

        break

      }#THEN

    }#FOR

    # if the Markov blanket is unchanged exit the grow phase.
    if (length(mb) == mb.size) break

  }#REPEAT

  return(mb)

}#GS.MARKOV.BLANKET

